import 'package:nui_core/nui_core.dart';
import 'nui_color_theme.dart';

class NUIThemeConfig extends NUIEnt<NUIThemeConfig>{
  NUIThemeConfig.empty();
  NUIColorTheme _lightTheme;
  NUIColorTheme _darkTheme;
  bool _startWithDark;

  NUIColorTheme get lightTheme => _lightTheme;
  NUIColorTheme get darkTheme => _darkTheme;
  bool get isStartWithDark => _startWithDark ?? false;

  @override
  NUIEntMapper<NUIThemeConfig> mapper() => NUIThemeConfigEnt();
}

class NUIThemeConfigEnt extends NUIEntMapper<NUIThemeConfig>{
  @override
  String entityName() => "NUIThemeConfig";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUIThemeConfig>(name: "lightTheme", type: NUIEntType.OBJECT, setter: (data, value) => data._lightTheme = asObject<NUIColorTheme>(NUIColorThemeEnt(), value), getter: (data) => data._lightTheme),
      NUIEntField<NUIThemeConfig>(name: "darkTheme", type: NUIEntType.OBJECT, setter: (data, value) => data._darkTheme = asObject<NUIColorTheme>(NUIColorThemeEnt(), value), getter: (data) => data._darkTheme),
      NUIEntField<NUIThemeConfig>(name: "startWithDark", type: NUIEntType.BOOLEAN, setter: (data, value) => data._startWithDark = value, getter: (data) => data._startWithDark),
    ];
  }

  @override
  NUIThemeConfig newInstance() => NUIThemeConfig.empty();
}